# coding: utf-8

"""
    Cashfree Payment Gateway APIs

    Cashfree's Payment Gateway APIs provide developers with a streamlined pathway to integrate advanced payment processing capabilities into their applications, platforms and websites.

    The version of the OpenAPI document: 2023-08-01
    Contact: developers@cashfree.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
from inspect import getfullargspec
import json
import pprint
import re  # noqa: F401

from typing import Any, List, Optional
from pydantic import BaseModel, Field, StrictStr, ValidationError, validator
from cashfree_pg.models.create_subscription_payment_auth_response import CreateSubscriptionPaymentAuthResponse
from cashfree_pg.models.create_subscription_payment_charge_response import CreateSubscriptionPaymentChargeResponse
from typing import Union, Any, List, TYPE_CHECKING
from pydantic import StrictStr, Field

SUBSCREATEPAYMENT200RESPONSE_ONE_OF_SCHEMAS = ["CreateSubscriptionPaymentAuthResponse", "CreateSubscriptionPaymentChargeResponse"]

class SubsCreatePayment200Response(BaseModel):
    """
    SubsCreatePayment200Response
    """
    # data type: CreateSubscriptionPaymentAuthResponse
    oneof_schema_1_validator: Optional[CreateSubscriptionPaymentAuthResponse] = None
    # data type: CreateSubscriptionPaymentChargeResponse
    oneof_schema_2_validator: Optional[CreateSubscriptionPaymentChargeResponse] = None
    if TYPE_CHECKING:
        actual_instance: Union[CreateSubscriptionPaymentAuthResponse, CreateSubscriptionPaymentChargeResponse]
    else:
        actual_instance: Any
    one_of_schemas: List[str] = Field(SUBSCREATEPAYMENT200RESPONSE_ONE_OF_SCHEMAS, const=True)

    class Config:
        validate_assignment = True

    def __init__(self, *args, **kwargs):
        if args:
            if len(args) > 1:
                raise ValueError("If a position argument is used, only 1 is allowed to set `actual_instance`")
            if kwargs:
                raise ValueError("If a position argument is used, keyword arguments cannot be used.")
            super().__init__(actual_instance=args[0])
        else:
            super().__init__(**kwargs)

    @validator('actual_instance')
    def actual_instance_must_validate_oneof(cls, v):
        instance = SubsCreatePayment200Response.construct()
        error_messages = []
        match = 0
        # validate data type: CreateSubscriptionPaymentAuthResponse
        if not isinstance(v, CreateSubscriptionPaymentAuthResponse):
            error_messages.append(f"Error! Input type `{type(v)}` is not `CreateSubscriptionPaymentAuthResponse`")
        else:
            match += 1
        # validate data type: CreateSubscriptionPaymentChargeResponse
        if not isinstance(v, CreateSubscriptionPaymentChargeResponse):
            error_messages.append(f"Error! Input type `{type(v)}` is not `CreateSubscriptionPaymentChargeResponse`")
        else:
            match += 1
        if match > 1:
            # more than 1 match
            raise ValueError("Multiple matches found when setting `actual_instance` in SubsCreatePayment200Response with oneOf schemas: CreateSubscriptionPaymentAuthResponse, CreateSubscriptionPaymentChargeResponse. Details: " + ", ".join(error_messages))
        elif match == 0:
            # no match
            raise ValueError("No match found when setting `actual_instance` in SubsCreatePayment200Response with oneOf schemas: CreateSubscriptionPaymentAuthResponse, CreateSubscriptionPaymentChargeResponse. Details: " + ", ".join(error_messages))
        else:
            return v

    @classmethod
    def from_dict(cls, obj: dict) -> SubsCreatePayment200Response:
        return cls.from_json(json.dumps(obj))

    @classmethod
    def from_json(cls, json_str: str) -> SubsCreatePayment200Response:
        """Returns the object represented by the json string"""
        instance = SubsCreatePayment200Response.construct()
        error_messages = []
        match = 0

        # deserialize data into CreateSubscriptionPaymentAuthResponse
        try:
            instance.actual_instance = CreateSubscriptionPaymentAuthResponse.from_json_for_one_of(json_str)
            match += 1
            if (instance.actual_instance is not None):
                return instance
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))
        # deserialize data into CreateSubscriptionPaymentChargeResponse
        try:
            instance.actual_instance = CreateSubscriptionPaymentChargeResponse.from_json_for_one_of(json_str)
            match += 1
            if (instance.actual_instance is not None):
                return instance
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))

        if match > 1:
            # more than 1 match
            raise ValueError("Multiple matches found when deserializing the JSON string into SubsCreatePayment200Response with oneOf schemas: CreateSubscriptionPaymentAuthResponse, CreateSubscriptionPaymentChargeResponse. Details: " + ", ".join(error_messages))
        elif match == 0:
            # no match
            raise ValueError("No match found when deserializing the JSON string into SubsCreatePayment200Response with oneOf schemas: CreateSubscriptionPaymentAuthResponse, CreateSubscriptionPaymentChargeResponse. Details: " + ", ".join(error_messages))
        else:
            return instance

    def to_json(self) -> str:
        """Returns the JSON representation of the actual instance"""
        if self.actual_instance is None:
            return "null"

        to_json = getattr(self.actual_instance, "to_json", None)
        if callable(to_json):
            return self.actual_instance.to_json()
        else:
            return json.dumps(self.actual_instance)

    def to_dict(self) -> dict:
        """Returns the dict representation of the actual instance"""
        if self.actual_instance is None:
            return None

        to_dict = getattr(self.actual_instance, "to_dict", None)
        if callable(to_dict):
            return self.actual_instance.to_dict()
        else:
            # primitive type
            return self.actual_instance

    def to_str(self) -> str:
        """Returns the string representation of the actual instance"""
        return pprint.pformat(self.dict())


